Sub Main

	Dim dep(1 To 15) As Double

	page_orientation$="P"

	On Error Resume Next 'Turn off error reporting.
	Set surf = GetObject(,"Surfer.Application")
	If Err.Number<>0 Then
		Set surf = CreateObject("Surfer.Application")
		surf.Documents.Add(srfDocPlot)
	End If
	On Error GoTo 0 'Turn on error reporting.

	'surf.Visible = True
	surf.WindowState = srfWindowStateMaximized
	surf.WindowState = srfZoomFitToWindow
	Debug.Clear

	Set plotdoc1 = surf.Documents(1)
		If plotdoc1.Type <> srfDocPlot Then plotdoc1 = surf.Documents.Add
	 	Set plotwin1 = surf.Windows(1)

		If Page_orientation$="A" Then
			With plotdoc1.PageSetup
				.Orientation = srfLandscape
	      		.Height =21.5
	      		.Width = 27.9
			End With
		Else
			With plotdoc1.PageSetup
				.Orientation = srfPortrait
	      		.Height =27.9
	      		.Width = 21.5
			End With
		End If

		plotwin1.Zoom(srfZoomPage)

		Set shapes1 = plotdoc1.Shapes
		If shapes1.Count >0 Then
			shapes1.SelectAll
			plotdoc1.Selection.Delete
		End If
'-----------------------------------------------------------------------------------------------------------------------------------
'	PARAMETERS:
	path$= "D:\SCIENCE\LOTOS_7\FIG_files"
	Fcolor_scale="col_10_iso10_20"

	nsec=8
	dep(1)=5 : dep(2)=15 : dep(3)=25 : dep(4)=35 : dep(5)=45
	dep(6)=55 : dep(7)=65 : dep(8)=75 : dep(9)=30 : dep(10)=35
	dep(11)=45 : dep(12)=55 : dep(13)=65 : dep(14)=75 : dep(15)=100

	top0=27.0
	left0=1.0
	xstep=7.0
	ystep=8.0

	xmin1=97.5
	xmax1=99.7
	ymin1=1
	ymax1=3.4
	xmpp1=1
	ympp1=1
	xlen1=6.00
	ylen1=6.00

' parameters for vector map:
	Mgmin=0.00
	Mgmax=30.0
	Lmin=0.0
	Lmax=0.5
	Wmin=0.0
	Wmax=0.0
	Sfreq=2
'====================================================================================================================================

	isec=0

	For icol=1 To 4 Step 1
		ips=1
		If icol = 3 Then
		 	ips=2
			isec=0
		ElseIf icol = 4 Then
			ips=2
		End If

		left1=left0 +(icol-1)*xstep
		ps$=Right(Str(ips),1)
		nrow=nsec/2
		For irow=1 To nrow Step 1
			top1=top0 -(irow-1)*ystep
			isec=isec+1
			iz=isec
			sec$=Right(Str(isec),2)

			Debug.Print "AddCounterMap"
			Set map1=shapes1.AddContourMap(path$+"\hor\dv"+ps$+"_"+sec$+".grd")
				Set cmp = map1.Overlays("Contours")
				cmp.ShowColorScale = False
				cmp.FillContours = True
				cmp.Levels.LoadFile(FileName:=path$+"\"+Fcolor_scale)

			Debug.Print "AddPostMap: Volcanoes"
			Set map2=shapes1.AddPostMap(path$+"\coast\volc_TOBA.dat")
				Set cpm = map2.Overlays("Post")
				cpm.LabCol = 0
				cpm.LabelFont.Size = 6
				cpm.LabelPos = srfPostPosRight
				With cpm.Symbol
					.Set = "GSI Default Symbols"
					.Index = 16
					.Color = srfColorRubyRed
					.Size=0.25
				End With


			Debug.Print "addBaseMap Java contour"
			Set map3=shapes1.AddBaseMap(path$+"\coast\coast_TOBA.bln")
				Set Base1 = map3.Overlays("Base")
				base1.Line.ForeColor = srfColorBlack
				base1.Line.Width = 0.03

			Debug.Print "AddPostMap: Events"
			Set map5=shapes1.AddPostMap(path$+"\hor\ztr"+sec$+".dat")
				Set cpm = map5.Overlays("Post")
				cpm.LabCol = 0
				cpm.LabelFont.Size = 6
				cpm.LabelPos = srfPostPosRight
				With cpm.Symbol
					.Set = "GSI Default Symbols"
					.Index = 12
					.Color = srfColorBlack
					.Size=0.03
				End With


			plotdoc1.Selection.DeselectAll

			map1.Selected = True
			map3.Selected = True
			map2.Selected = True
			map5.Selected = True
		'	map4.Selected = True

			plotdoc1.Selection.OverlayMaps

			map1.SetLimits(xMin:=xMin1, xMax:=xMax1, yMin:=yMin1, yMax:=yMax1)

			depth$=Str(dep(iz))
			If ips=1 Then tname$="P, depth"+depth$+" km"
			If ips=2 Then tname$="S, depth"+depth$+" km"

			With map1
				'.xMapPerPU = xmpp1
				'.yMapPerPU = ympp1
				.xLength = xlen1
				.yLength = ylen1
				.Top = Top1
				.Left = Left1
				.Axes("Bottom Axis").LabelFont.Size = 10
				.Axes("Left Axis").LabelFont.Size = 10
				With .Axes("Top Axis")
					.Title = tname$
					.TitleFont.Size = 12
					'.TitleFont.Bold = True
				End With
			End With
		Next
	Next





End Sub
