Sub Main

	Dim dep(1 To 15) As Double

	page_orientation$="P"

	On Error Resume Next 'Turn off error reporting.
	Set surf = GetObject(,"Surfer.Application")
	If Err.Number<>0 Then
		Set surf = CreateObject("Surfer.Application")
		surf.Documents.Add(srfDocPlot)
	End If
	On Error GoTo 0 'Turn on error reporting.

	'surf.Visible = True
	surf.WindowState = srfWindowStateMaximized
	surf.WindowState = srfZoomFitToWindow
	Debug.Clear

	Set plotdoc1 = surf.Documents(1)
		If plotdoc1.Type <> srfDocPlot Then plotdoc1 = surf.Documents.Add
	 	Set plotwin1 = surf.Windows(1)

		If Page_orientation$="A" Then
			With plotdoc1.PageSetup
				.Orientation = srfLandscape
	      		.Height =21.5
	      		.Width = 27.9
			End With
		Else
			With plotdoc1.PageSetup
				.Orientation = srfPortrait
	      		.Height =27.9
	      		.Width = 21.5
			End With
		End If

		plotwin1.Zoom(srfZoomPage)

		Set shapes1 = plotdoc1.Shapes
		If shapes1.Count >0 Then
			shapes1.SelectAll
			plotdoc1.Selection.Delete
		End If
'-----------------------------------------------------------------------------------------------------------------------------------
'	PARAMETERS:
	path$= "F:\SCIENCE\_LOCAL_TOMO_PROG\LOTOS_9\FIG_files"
	Fcolor_scale="color_scale_10_10"

	nsec=8
	dep(1)=10 : dep(2)=30 : dep(3)=50 : dep(4)=70 : dep(5)=90
	dep(6)=110 : dep(7)=130 : dep(8)=150 : dep(9)=180 : dep(10)=35
	dep(11)=45 : dep(12)=55 : dep(13)=65 : dep(14)=75 : dep(15)=100

	top0=27.0
	left0=1.0
	xstep=9.0
	ystep=8.0

	xmin1=25.5
	xmax1=28
	ymin1=44.5
	ymax1=46.5
	xmpp1=1
	ympp1=1
	xlen1=6.00
	ylen1=6.00

' parameters for vector map:
	Mgmin=0.00
	Mgmax=30.0
	Lmin=0.0
	Lmax=0.5
	Wmin=0.0
	Wmax=0.0
	Sfreq=2
'====================================================================================================================================

	For ips=1 To 2 Step 1
		left1=left0 +(ips-1)*xstep
		ps$=Right(Str(ips),1)
		For isec=1 To nsec Step 1
			iz=isec
			top1=top0 -(isec-1)*ystep
			sec$=Right(Str(isec),2)

			Debug.Print "AddCounterMap"
			Set map1=shapes1.AddContourMap(path$+"\hor\dv"+ps$+"5"+sec$+".grd")
				Set cmp = map1.Overlays("Contours")
				cmp.ShowColorScale = False
				cmp.FillContours = True
				cmp.Levels.LoadFile(FileName:=path$+"\"+Fcolor_scale)



			Debug.Print "addBaseMap Rivers"
			Set map2=shapes1.AddBaseMap(path$+"\coast\vranchea\rivers.bln")
				Set Base1 = map2.Overlays("Base")
				base1.Line.ForeColor = srfColorBabyBlue
				base1.Line.Width = 0.03

			Debug.Print "addBaseMap Polit bound"
			Set map3=shapes1.AddBaseMap(path$+"\coast\vranchea\polit_bound.bln")
				Set Base1 = map3.Overlays("Base")
				base1.Line.ForeColor = srfColorBlack
				base1.Line.Width = 0.03

			Debug.Print "AddPostMap: Events"
			Set map5=shapes1.AddPostMap(path$+"\hor\ztr"+sec$+".dat")
				Set cpm = map5.Overlays("Post")
				cpm.LabCol = 0
				cpm.LabelFont.Size = 6
				cpm.LabelPos = srfPostPosRight
				With cpm.Symbol
					.Set = "GSI Default Symbols"
					.Index = 12
					.Color = srfColorBlack
					.Size=0.05
				End With


			plotdoc1.Selection.DeselectAll

			map1.Selected = True
			map3.Selected = True
			map2.Selected = True
			map5.Selected = True
		'	map4.Selected = True

			plotdoc1.Selection.OverlayMaps

			map1.SetLimits(xMin:=xMin1, xMax:=xMax1, yMin:=yMin1, yMax:=yMax1)

			depth$=Str(dep(iz))
			If ips=1 Then tname$="P, depth"+depth$+" km"
			If ips=2 Then tname$="S, depth"+depth$+" km"

			With map1
				'.xMapPerPU = xmpp1
				'.yMapPerPU = ympp1
				.xLength = xlen1
				.yLength = ylen1
				.Top = Top1
				.Left = Left1
				.Axes("Bottom Axis").LabelFont.Size = 10
				.Axes("Left Axis").LabelFont.Size = 10
				With .Axes("Top Axis")
					.Title = tname$
					.TitleFont.Size = 12
					'.TitleFont.Bold = True
				End With
			End With
		Next
	Next





End Sub
