character*8 re,ar,line
character*1 ps,gr
character*2 lv

real block(:,:,:),dep(20),ornt(10)
integer nblock(2),nsos(2),kod_bl(10000)
common/pi/pi,per

allocatable block


one=1.d0
pi=asin(one)*2.d0
per=pi/180.d0


open(1,file='SET.DAT')
read(1,'(a8)')re
read(1,'(a8)')ar
read(1,*)igr
read(1,*)ndepth
read(1,*)(dep(i),i=1,ndepth)
close(1)
write(gr,'(i1)')igr

!******************************************************************
open(1,file='../../data/'//re//'/'//ar//'/ini_param/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=573)line
	if(line.eq.'ORIENTAT') goto 574
end do
573 continue
write(*,*)' cannot find ORIENTATIONS in MAJOR_PARAM.DAT!!!'
pause
574 read(1,*)nornt
read(1,*)(ornt(i),i=1,nornt)
close(1)
!******************************************************************
orient=ornt(igr)
write(*,*)' orient=',orient
sinbase=sin(-orient*per)
cosbase=cos(-orient*per)


!******************************************************************
open(1,file='../../data/'//re//'/'//ar//'/ini_param/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=553)line
	if(line.eq.'AREA_CEN') goto 554
end do
553 continue
write(*,*)' cannot find AREA CENTER in MAJOR_PARAM.DAT!!!'
pause
554 read(1,*)fi0,tet0
write(*,*)fi0,tet0
close(1)
!******************************************************************


open(1,file='../../data/'//re//'/'//ar//'/grids/nblock'//gr//'.dat')
read(1,*) nblock(1),nblock(2)
read(1,*) nsos(1),nsos(2)
!write(*,*) nsos(1),nsos(2)
close(1)

nblmax=nblock(1)
if (nblock(2).gt.nblmax) nblmax=nblock(2)

allocate (block(2,nblmax,6))

do iiips=1,2
	write(ps,'(i1)')iiips

	open(1,file='../../data/'//re//'/'//ar//'/grids/block'//ps//gr//'.dat')
	do ibl=1,nblock(iiips)
		read(1,*)x1,x2,y1,y2,z1,z2
		block(iiips,ibl,1)=x1
		block(iiips,ibl,2)=x2
		block(iiips,ibl,3)=y1
		block(iiips,ibl,4)=y2
		block(iiips,ibl,5)=z1
		block(iiips,ibl,6)=z2
	end do
	close(1)
	do il=1,ndepth
		depth=dep(il)
		write(lv,'(i2)')il
		open(21,file='../../FIG_files/cells/cell'//ps//'_'//lv//'.bln')


		ikod=0
		do ibl=1,nblock(iiips)
			x1=block(iiips,ibl,1)
			x2=block(iiips,ibl,2)
			y1=block(iiips,ibl,3)
			y2=block(iiips,ibl,4)
			z1=block(iiips,ibl,5)
			z2=block(iiips,ibl,6)
			
			if ((depth-z1)*(depth-z2).ge.0) cycle
			ikod=ikod+1
			kod_bl(ikod)=ibl
			

			write(21,*) 5
			xx1=x1*cosbase+y1*sinbase
			yy1=y1*cosbase-x1*sinbase
			call decsf(xx1,yy1,depth,fi0,tet0,ff1,tt1,h)
			write(21,*) ff1,tt1
			xx=x2*cosbase+y1*sinbase
			yy=y1*cosbase-x2*sinbase
			call decsf(xx,yy,depth,fi0,tet0,ff,tt,h)
			write(21,*) ff,tt
			xx=x2*cosbase+y2*sinbase
			yy=y2*cosbase-x2*sinbase
			call decsf(xx,yy,depth,fi0,tet0,ff,tt,h)
			write(21,*) ff,tt
			xx=x1*cosbase+y2*sinbase
			yy=y2*cosbase-x1*sinbase
			call decsf(xx,yy,depth,fi0,tet0,ff,tt,h)
			write(21,*) ff,tt
			write(21,*) ff1,tt1
		end do
		close(21)

		!do i=1,ikod
			!write(*,*)i,kod_bl(i)
		!end do
		cycle

		open(2,file='../../tmp/otr'//ps//gr//'.dat',form='binary')
		open(21,file='../../FIG_files/cells/otr'//ps//'_'//lv//'.bln')
		notr=0
		do isos=1,nsos(iiips)
			read(2)ipar1,ipar2

			do i1=1,ikod
				if(ipar1.ne.kod_bl(i1)) cycle
				
				do i2=1,ikod
					if(ipar2.ne.kod_bl(i2)) cycle
					goto 23
				end do
			end do
			goto 24

23			continue
			!write(*,*)' ipar1=',ipar1,' ipar2=',ipar2


			notr=notr+1

			x1=(block(iiips,ipar1,1)+block(iiips,ipar1,2))/2.
			y1=(block(iiips,ipar1,3)+block(iiips,ipar1,4))/2.
			z1=(block(iiips,ipar1,5)+block(iiips,ipar1,6))/2.

			x2=(block(iiips,ipar2,1)+block(iiips,ipar2,2))/2.
			y2=(block(iiips,ipar2,3)+block(iiips,ipar2,4))/2.
			z2=(block(iiips,ipar2,5)+block(iiips,ipar2,6))/2.

			!write(*,*)' x1=',x1,' y1=',y1,' z1=',z1
			!write(*,*)' x2=',x2,' y2=',y2,' z2=',z2
			write(21,*) 2
			xx1=x1*cosbase+y1*sinbase
			yy1=y1*cosbase-x1*sinbase
			call decsf(xx1,yy1,depth,fi0,tet0,ff1,tt1,h)
			write(21,*) ff1,tt1
			xx=x2*cosbase+y2*sinbase
			yy=y2*cosbase-x2*sinbase
			call decsf(xx,yy,depth,fi0,tet0,ff,tt,h)
			write(21,*) ff,tt
24			continue
		end do
		close(2)

		write(*,*)' ips=',iiips,' depth=',depth,' ikod=',ikod,' notr=',notr

	end do



end do




stop
end