function velocity_hor_anis(x,y,z,ips,al,bet)
! This function produces the velocity in direction al, bet, using 3D distribution of
! slowness in 4 directions (slw_0, slw_60, slw_120, slw_z)

common/pi/pi,per
common/center/fi0,tet0

v0=vrefmod(z,ips)
s0=1/v0

call anom_3D_xyz_slw(x,y,z,ips, dslw_0, dslw_60, dslw_120, dslw_z)

dalfa=al
if(dalfa.le.-90.) dalfa=dalfa+180
dsss1 = (cos(dalfa*2.*per)+1.) * dslw_0 / 3.

dalfa=al-60.
if(dalfa.le.-90.) dalfa=dalfa+180
dsss2 = (cos(dalfa*2.*per)+1.) * dslw_60 / 3.

dalfa=al+60.
if(dalfa.gt.90.) dalfa=dalfa-180
dsss3 = (cos(dalfa*2.*per)+1.) * dslw_120 / 3.


dshor = dsss1 + dsss2 + dsss3

dsss4= abs(cos(bet*per)) * dslw_z
sinb=abs(sin(bet*per))
cosb=abs(cos(bet*per))


ds=(dshor * sinb + dslw_z * cosb) / (sinb + cosb)


sabs=s0+ds
!write(*,*)' ds=',ds,' dslw_0=',dslw_0
!pause


vabs=1./sabs

velocity_hor_anis = vabs

return
end