subroutine part_bending_hor(xzt,yzt,zzt,xst,yst,zst,ips,&
		part1,part2,val_bend, tout)

common/ray/ nodes,xray(1000),yray(1000),zray(1000)

real xtmp(1000),ytmp(1000),ztmp(1000)
real dxray(1000),dyray(1000),dzray(1000)

!nodes=nini
!xray=xini
!yray=yini
!zray=zini

sss=0
do inode=1,nodes-1
	x1=xray(inode)
	x2=xray(inode+1)

	y1=yray(inode)
	y2=yray(inode+1)

	z1=zray(inode)
	z2=zray(inode+1)

	ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1))

	sss=sss+ds
	!write(*,*)' t=',ttt,' s=',sss,' vvv=',vvv
end do
!write(*,*)' sss=',sss,' nodes=',nodes
s1=part1*sss
s2=part2*sss


ntmp=0
sss=0

npart1=1
npart2=nodes

do inode=1,nodes-1
	x1=xray(inode)
	x2=xray(inode+1)

	y1=yray(inode)
	y2=yray(inode+1)

	z1=zray(inode)
	z2=zray(inode+1)

	ntmp=ntmp+1
	xtmp(ntmp)=x1
	ytmp(ntmp)=y1
	ztmp(ntmp)=z1

	ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1))

	if(abs(sss-s1).le.0.00001) npart1=ntmp
	if(s1.gt.(sss+0.00001).and.s1.lt.(sss+ds-0.00001)) then
		ntmp=ntmp+1
		xtmp(ntmp)=x1+((x2-x1)/ds)*(s1-sss)
		ytmp(ntmp)=y1+((y2-y1)/ds)*(s1-sss)
		ztmp(ntmp)=z1+((z2-z1)/ds)*(s1-sss)
		npart1=ntmp
	end if

	if(abs(sss-s2).le.0.00001) npart1=ntmp
	if(s2.gt.(sss+0.00001).and.s2.lt.(sss+ds-0.00001)) then
		ntmp=ntmp+1
		xtmp(ntmp)=x1+((x2-x1)/ds)*(s2-sss)
		ytmp(ntmp)=y1+((y2-y1)/ds)*(s2-sss)
		ztmp(ntmp)=z1+((z2-z1)/ds)*(s2-sss)
		npart2=ntmp
	end if


	sss=sss+ds
	!write(*,*)' t=',ttt,' s=',sss,' vvv=',vvv
end do
ntmp=ntmp+1
xtmp(ntmp)=xray(nodes)
ytmp(ntmp)=yray(nodes)
ztmp(ntmp)=zray(nodes)

!write(*,*)' nodes=',nodes,' npart1=',npart1,' npart2=',npart2

nodes=ntmp
xray=xtmp
yray=ytmp
zray=ztmp

sss2=(s2-s1)/2.

sss=-sss2
dxray=0
dyray=0
dzray=0
scur=0
do inode=2,nodes-1


	x1=xray(inode-1)
	y1=yray(inode-1)
	z1=zray(inode-1) 

	x2=xray(inode)
	y2=yray(inode)
	z2=zray(inode)

	ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1))
	scur=scur+ds

	if(inode.le.npart1) cycle
	if(inode.ge.npart2) exit

	x3=xray(inode+1)
	y3=yray(inode+1)
	z3=zray(inode+1)

	dh=sqrt((x3-x1)*(x3-x1)+(y3-y1)*(y3-y1))
	dist=sqrt((z3-z1)*(z3-z1)+dh*dh)
	cosb=(x3-x1)/dh
	sinb=(y3-y1)/dh

	sss=sss+ds

	d_value = val_bend * (1-(sss*sss)/(sss2*sss2))

	!write(*,*)' sss=',sss,' scur=',scur,' d=',d_value

	dxray(inode)= - d_value * sinb
	dyray(inode)=   d_value * cosb
	dzray(inode)= 0.
	!write(*,*)inode,dxray(inode),dyray(inode),dzray(inode)

end do

xray = xray + dxray
yray = yray + dyray
zray = zray + dzray


!do i=1,nodes
!	write(*,*)xray(i),yray(i),zray(i)
!end do

ttt=0
sss=0
zmax=0
do inode=1,nodes-1
	x1=xray(inode)
	x2=xray(inode+1)
	xm=(x1+x2)/2.

	y1=yray(inode)
	y2=yray(inode+1)
	ym=(y1+y2)/2.

	
	z1=zray(inode) 
	z2=zray(inode+1) 
	if(z1.gt.zmax) zmax=z1
	if(z2.gt.zmax) zmax=z2
	zm=(z1+z2)/2.

	ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1))
	!write(*,*)inode,ds,xm,ym,zm

	sss=sss+ds
	vvv=velocity (xm,ym,zm,ips)
	ttt=ttt+ds/vvv
	!write(*,*)' ttt=',ttt,' zm=',zm,' ds=',ds,' vvv=',vvv
end do
!pause

tout=ttt

!write(*,*)nodes,' zmax=',zmax,' ttt=',ttt,' sss=',sss


return
end