USE DFPORT
character*8 ar,ar_syn,ar_real,line
character*8 re,re_syn,re_real
character*1 rg_all(100),rg
common/refmod/nrefmod,hmod(600),vmodp(600),vmods(600)

open(61, file='../../kod_syn_all.dat')
read(61,*) num_models
read(61,*) 
read(61,*) 
read(61,*) 
do imodel=1,num_models

	read(61,'(a8,3x,a8,3x,i1))')re_syn,re_real
	read(61,'(a8,3x,a8,3x,i1,3x,i1))')ar_syn,ar_real,niter,kod_1d
	read(61,*)

	i=system('mkdir ..\..\DATA\'//re_syn//'\'//ar_syn//'\3D_model')
	i=system('mkdir ..\..\DATA\'//re_syn//'\'//ar_syn//'\grids')
	i=system('mkdir ..\..\DATA\'//re_syn//'\'//ar_syn//'\result')
	i=system('mkdir ..\..\DATA\'//re_syn//'\'//ar_syn//'\times')


	write(*,*)' input:',ar_real
	write(*,*)' output:',ar_syn
	write(*,*)' iterations:',niter

	open(11, file='../../kod_syn.dat')
	write(11,'(a8,1x,a8)')re_syn,ar_syn		
	write(11,'(a8,1x,a8)')re_real,ar_real		
	close(11)

	ar=ar_syn
	re=re_syn

	open(11,file='../../DATA/'//re//'/'//ar//'/real_or_syn.dat')
	write(11,*)2
	close(11)

	open(11,file='../../model.dat')
	write(11,'(a8)')re		
	write(11,'(a8)')ar		
	write(11,*)1		
	write(11,*)1		
	write(11,*)0		
	close(11)

	i=system('..\a_set_syn_hor\create.exe')
	i=system('..\a_set_syn_ver\create.exe')

	write(*,*)'	 ****************************************************'
	write(*,*)'	 Compute the synthetic times: '

	i=system('..\b_synth_times\rays.exe')


	if(kod_1d.ne.0) then

		open(1,file='../../DATA/'//re//'/'//ar//'/ini_param/ref_syn.dat')
		read(1,*,end=81)vpvs
		i=0
		82	i=i+1
			read(1,*,end=81)hmod(i),vmodp(i),vs
			if(vpvs.lt.0.000001) then
				vmods(i)=vs
			else
				vmods(i)=vmodp(i)/vpvs
			end if
			!write(*,*)hmod(i),vmodp(i),vmods(i)
		goto 82
		81	close(1)
		nrefmod=i-1
		!write(*,*)' nrefmod=',nrefmod


		open(21,file='../../DATA/'//re//'/'//ar//'/result/ref_true.bln')
		write(21,*)nrefmod
		do i=1,nrefmod
			write(21,*)vmodp(i),-hmod(i)
		end do
		write(21,*)nrefmod
		do i=1,nrefmod
			write(21,*)vmods(i),-hmod(i)
		end do
		close(21)

		open(1,file='../../DATA/'//re//'/'//ar//'/ini_param/ref_start.dat')
		read(1,*,end=81)vpvs
		i=0
		182	i=i+1
			read(1,*,end=181)hmod(i),vmodp(i),vs
			if(vpvs.lt.0.000001) then
				vmods(i)=vs
			else
				vmods(i)=vmodp(i)/vpvs
			end if
			!write(*,*)hmod(i),vmodp(i),vmods(i)
		goto 182
		181	close(1)
		nrefmod=i-1
		!write(*,*)' nrefmod=',nrefmod


		open(21,file='../../DATA/'//re//'/'//ar//'/result/ref_start.bln')
		write(21,*)nrefmod
		do i=1,nrefmod
			write(21,*)vmodp(i),-hmod(i)
		end do
		write(21,*)nrefmod
		do i=1,nrefmod
			write(21,*)vmods(i),-hmod(i)
		end do
		close(21)

		i=system('copy ..\..\DATA\'//re//'\'//ar//'\ini_param\ref_start.dat &
		..\..\DATA\'//re//'\'//ar//'\ini_param\refmod.dat')

		i=system('..\..\PROG_1D_MODEL\0_1_ref_rays\refrays.exe')
		i=system('..\..\PROG_1D_MODEL\0_2_loc_event\locate.exe')


		open(11,file='../../model.dat')
		write(11,'(a8)')re		
		write(11,'(a8)')ar		
		close(11)
		i=system('..\..\PROG_1D_MODEL\START_1D\start_real.exe')

	end if

	open(11,file='../../model.dat')
	write(11,'(a8)')re		
	write(11,'(a8)')ar		
	write(11,'(i1)')1		
	write(11,'(i1)')1	
	write(11,'(i1)')
	close(11)


	i=system('..\..\PROG_1D_MODEL\0_1_ref_rays\refrays.exe')
	i=system('..\..\PROG_1D_MODEL\0_2_loc_event\locate.exe')


	!******************************************************************
	open(1,file='../../data/'//re//'/'//ar//'/ini_param/MAJOR_PARAM.DAT')
	do i=1,10000
		read(1,'(a8)',end=573)line
		if(line.eq.'ORIENTAT') goto 574
	end do
	573 continue
	write(*,*)' cannot find ORIENTATIONS in MAJOR_PARAM.DAT!!!'
	pause
	574 read(1,*)nornt
	close(1)
	!******************************************************************
	kod_param=1
	open(1,file='../../data/'//re//'/'//ar//'/ini_param/MAJOR_PARAM.DAT')
	do i=1,10000
		read(1,'(a8)',end=513)line
		if(line.eq.'GRID_PAR') goto 514
	end do
	513 continue
	write(*,*)' cannot find GRID PARAMETERS in MAJOR_PARAM.DAT!!!'
	pause
	514 continue
	read(1,*)
	read(1,*)
	read(1,*)
	read(1,*)kod_param
	close(1)
	!******************************************************************



	! Execute the inversion for grids with different orientations:
	do iter=1,niter	
		write(*,*)
		write(*,*)
		write(*,*)
		write(*,*)
		write(*,*)' model:',ar,' iteration:',iter


		open(11,file='../../model.dat')
		write(11,'(a8)')re		
		write(11,'(a8)')ar		
		write(11,'(i1)')iter		
		write(11,'(i1)')1	
		close(11)

		write(*,*)'	 ****************************************************'
		write(*,*)'	 Source location'

		i=system('..\1_locate\locate.exe')


		if(kod_param.eq.1) then

			do igr=1,nornt
				open(11,file='../../model.dat')
				write(11,'(a8)')re		
				write(11,'(a8)')ar		
				write(11,'(i1)')iter		
				write(11,'(i1)')igr	
				close(11)
				if(iter.eq.1) then

					write(*,*)'	 ****************************************************'
					write(*,*)'	 Compute the ray density'
					i=system('..\2_ray_density\plotray.exe')
					write(*,*)'	 ****************************************************'
					write(*,*)'	 Compute the parameterization grid:'
					i=system('..\3_grid\grid.exe')
					i=system('..\4_tetrad\Tetrad.exe')
					i=system('..\5_sosedi\add_matr.exe')
				end if

				i=system('..\6_matr\matr.exe')
				i=system('..\7_invers\Invbig.exe')
			end do ! Different grids
			i=system('..\8_3D_model\mod_3D.exe')
			i=system('..\9n_hor_result\visual.exe')
			i=system('..\9n_ver_result\visual.exe')


		else if(kod_param.eq.2) then

			do igr=1,nornt
				open(11,file='../../model.dat')
				write(11,'(a8)')re		
				write(11,'(a8)')ar		
				write(11,'(i1)')iter		
				write(11,'(i1)')igr	
				close(11)
				if(iter.eq.1) then

					write(*,*)'	 ****************************************************'
					write(*,*)'	 Compute the ray density'
					i=system('..\2a_ray_density\plotray.exe')
					write(*,*)'	 ****************************************************'
					write(*,*)'	 Compute the parameterization grid:'
					i=system('..\3a_grid\block.exe')
				end if
				i=system('..\6a_matr\matr_hor.exe')
				i=system('..\7a_invers\Invers_hor.exe')
			end do
			i=system('..\8a_3D_model\3D_model_block.exe')
			i=system('..\9b_hor_result\visual.exe')
			i=system('..\9b_ver_result\visual.exe')

		end if

	end do ! Different iterations

end do
close(1)

stop
end