! HORIZONTAL !!!
! BLOCKS !!!!!!!

program visual_hor
character*8 re,ar,line
character*2 lv
character*1 it,ps
character*4 dsaa/'DSAA'/

real hlev(20)
real far(100),tar(100)

allocatable dviso(:,:),tmp1(:,:),vvv(:,:)


common/pi/pi,per
common/center/fi0,tet0
common/refmod/nrefmod,hmod(600),vmodp(600),vmods(600)

one=1.e0
pi=asin(one)*2.e0
per=pi/180.e0

w_limit=0.5

open(1,file='../../VISUAL/area.dat')
read(1,'(a8)')re
read(1,'(a8)')ar
read(1,*) iter
read(1,*) ngr1,ngr2
close(1)

write(*,*)' ar=',ar,' re=',re
write(*,*)' grids:',ngr1,ngr2,' iter=',iter

!******************************************************************
open(1,file='../../data/'//re//'/'//ar//'/ini_param/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=553)line
	if(line.eq.'AREA_CEN') goto 554
end do
553 continue
write(*,*)' cannot find AREA CENTER in MAJOR_PARAM.DAT!!!'
pause
554 read(1,*)fi0,tet0
write(*,*)fi0,tet0
close(1)
!******************************************************************

open(2,file='../../data/'//re//'/'//ar//'/ini_param/sethor.dat')
read(2,*) nlev  
read(2,*) (hlev(i),i=1,nlev)  
read(2,*) fmap1,fmap2,dfmap,tmap1,tmap2,dtmap  
read(2,*) smaxx
read(2,*) ismth
close(2)

rsmth=ismth+0.5
nfmap=int_best((fmap2-fmap1)/dfmap+1.)
ntmap=int_best((tmap2-tmap1)/dtmap+1.)
write(*,*)' nfmap=',nfmap,' ntmap=',ntmap


allocate (dviso(nfmap,ntmap),tmp1(nfmap,ntmap),vvv(nfmap,ntmap))


open(1,file='../../data/'//re//'/'//ar//'/ini_param/good_area_all.bln')
nnod=0
read(1,*,end=228) nnod
	do i=1,nnod
		read(1,*)far(i),tar(i)
	end do
	far(nnod+1)=far(1)
	tar(nnod+1)=tar(1)
228 close(1)

!******************************************************************
open(1,file='../../data/'//re//'/'//ar//'/ini_param/MAJOR_PARAM.DAT')
do i=1,10000
	read(1,'(a8)',end=573)line
	if(line.eq.'ORIENTAT') goto 574
end do
573 continue
write(*,*)' cannot find ORIENTATIONS in MAJOR_PARAM.DAT!!!'
pause
574 read(1,*)nornt
close(1)
!******************************************************************

! Read the values of the reference model
open(1,file='../../DATA/'//re//'/'//ar//'/ini_param/refmod.dat')
read(1,*,end=81)vpvs
i=0
82	i=i+1
	read(1,*,end=81)hmod(i),vmodp(i),vs
	if(vpvs.lt.0.000001) then
		vmods(i)=vs
	else
		vmods(i)=vmodp(i)/vpvs
	end if
goto 82
81	close(1)
nrefmod=i-1

do ips=1,2
	write(ps,'(i1)')ips
	write(*,*) 'ips= ', ips
	do il=1,nlev
		zzz=hlev(il)
		vref=vrefmod(zzz,ips)
		write(lv,'(i2)')il
		write(*,*)' ilev=',il,' zzz=',zzz
		dviso=0.
		aniso=0.
		angle=0.
		dvver=0.
		vvv=0.
		al_old=0.
		do igr=ngr1,ngr2
			!write(*,*)'igr= ',igr
			call prepare_model_block(re,ar,ips,iter,igr)
			do itet=1,ntmap
				ttt=(itet-1)*dtmap+tmap1+tet0
				do ifi=1,nfmap
					fff=(ifi-1)*dfmap+fmap1+fi0

!fff=110.31297345
!fff=110.
!fff=110.41225951
					!write(*,*)fff,ttt

!ttt=-8.61681650286
!ttt=-9
!ttt=-8.25749649143
					call dv_1_gr_block_ftz(fff,ttt,zzz, dv1,www)


! Check wheather we are in a well resolved area defined in "good_area_all.bln"
					nn=0
					ntot=0
					if(nnod.gt.2) then
						do i=2,nnod+1
							if ( (fff-far(i))*(fff-far(i-1)).gt.0) cycle
							tar0=tar(i-1)+(fff-far(i-1))*(tar(i)-tar(i-1))/(far(i)-far(i-1))
							if (ttt.gt.tar0) nn=nn+1
							ntot=ntot+1
						end do
						nnn=ntot-nn
						if (abs(mod(nnn,2)).eq.0) www=0.
					end if
!********************************************************************************


! Isotrope anomaly
					dviso(ifi,itet)=dviso(ifi,itet)+dv1*www

					vvv(ifi,itet)=vvv(ifi,itet)+www

				end do	!ifi
			end do	!itet
		end do	!igr

		vmid=0.
		coef=0.
		do itet=1,ntmap
			do ifi=1,nfmap
				if (vvv(ifi,itet).gt.w_limit) then
					!write(*,*)dviso(ifi,itet),vvv(ifi,itet)
					dviso(ifi,itet)=dviso(ifi,itet)/vvv(ifi,itet)
				else
					dviso(ifi,itet)=-999
				end if
			end do
		end do

		if (ismth.eq.0) goto 10

		tmp1=-999.
		tmp2=0.
		tmp3=-999.
		do itet=1,ntmap
			do ifi=1,nfmap
				if(vvv(ifi,itet).lt.w_limit) cycle
				aaa=0.
				bbb=0.
				ccc=0.
				iv=0.
				do it2=-ismth,ismth
					if (itet+it2.lt.1) cycle
					if (itet+it2.gt.ntmap) cycle
					do if2=-ismth,ismth
						if (ifi+if2.lt.1) cycle
						if (ifi+if2.gt.nfmap) cycle
						if(vvv(ifi+if2,itet+it2).lt.w_limit) cycle
						rr=if2*if2+it2*it2
						r=sqrt(rr)
						if(r.gt.rsmth) cycle
						iv=iv+1
						aaa=aaa+dviso(ifi+if2,itet+it2)
					end do	!if2
				end do	!it2
				tmp1(ifi,itet)=aaa/iv
				!if (tmp2(ifi,itet).lt.0.5) tmp2(ifi,itet)=0.
			end do	!ixx
		end do	!iyy
		dviso=tmp1

10		continue

		open(14,file='../../FIG_files/hor/dv'//ps//'_'//lv//'.grd')
		write(14,'(a4)')dsaa
		write(14,*)nfmap,ntmap
		write(14,*)fmap1+fi0,fmap2+fi0
		write(14,*)tmap1+tet0,tmap2+tet0
		write(14,*)-999,999
		do itet=1,ntmap
			write(14,*)(dviso(ifi,itet),ifi=1,nfmap)
		end do
		close(14)

	end do	!ilv
end do	!ips

stop
end