subroutine read_3D_slw(re,ar,iter)
character*8 ar,re
character*1 ps,rm,it 
common/mod_3D/slw_xyz(2,150,150,100,4),xx1,nxx,dxx,yy1,nyy,dyy,zz1,nzz,dzz
common/zlimits/zmin,zmax
nxmax=150
nymax=150
nzmax=100

nxx=0
nyy=0
nzz=0

if(iter.lt.1) return

write(it,'(i1)')iter

slw_xyz=0

write(*,*)' Reading the 3D slowness model'

do ips=1,2
	write(ps,'(i1)')ips
	open(1,file='../../data/'//re//'/'//ar//'/3D_model/anis_xyz'//ps//it//'.dat',form='unformatted')

	read(1,end=14)xx1,nxx,dxx
	if(nxx.eq.0) cycle
	if(nxx.gt.nxmax) then
		write(*,*)' nxx > nxmax!'
		write(*,*)' Value of the nxx in common file "mod_3D" should be increased'
		pause
	end if

	read(1)yy1,nyy,dyy
	if(nyy.gt.nymax) then
		write(*,*)' nyy > nymax!'
		write(*,*)' Value of the nyy in common file "mod_3D" should be increased'
		pause
	end if


	read(1)zz1,nzz,dzz
	if(nzz.gt.nzmax) then
		write(*,*)' nzz > nzmax!'
		write(*,*)' Value of the nzz in common file "mod_3D" should be increased'
		pause
	end if
	do izz=1,nzz
		!if(mod(izz,5).eq.0) write(*,*)' ips=',ips,' izz=',izz
		do idir=1,4
			read(1)((slw_xyz(ips,ixx,iyy,izz,idir),ixx=1,nxx),iyy=1,nyy)
		end do
	end do

14	close(1)
end do


write(*,*)' nxx=',nxx,' nyy=',nyy,' nzz=',nzz


return
end