subroutine rough_bending(xzt,yzt,zzt,xst,yst,zst,ips, &
			ds_ini,val_bend0,bend_max,	tout)

common/ray/ nodes,xray(1000),yray(1000),zray(1000)
real xtmp(1000),ytmp(1000),ztmp(1000)
real xmin(1000),ymin(1000),zmin(1000)
real dxray(1000),dyray(1000),dzray(1000)

ds_ini = 2
val_bend0 = 2
bend_max0 = 30


dshor = sqrt((xst-xzt)*(xst-xzt)+(yst-yzt)*(yst-yzt))
dsver = abs(zzt-zst)
dstot = sqrt(dshor*dshor+dsver*dsver)

nodes = dstot/ds_ini

ds = dstot/nodes

zzt=0

write(*,*)' ztr:',xzt,yzt,zzt
do inode = 1,nodes+1
	sss = ds * (inode-1)
	xray(inode) = xzt + sss * (xst-xzt)/dstot
	yray(inode) = yzt + sss * (yst-yzt)/dstot
	zray(inode) = zzt + sss * (zst-zzt)/dstot
	!write(*,*) xray,yray,zray
end do
write(*,*)' sta:',xst,yst,zst

! Time along the streight line:

ddd=0
ttt=0
sss=0
do inode=1,nodes
	x1=xray(inode)
	x2=xray(inode+1)
	xm=(x1+x2)/2.

	y1=yray(inode)
	y2=yray(inode+1)
	ym=(y1+y2)/2.

	z1=zray(inode)
	z2=zray(inode+1)
	zm=(z1+z2)/2.

	ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1))
	vvv=velocity (xm,ym,zm,ips)
	ttt=ttt+ds/vvv
	sss=sss+ds
	!write(*,*)' t=',ttt,' s=',sss,' vvv=',vvv
end do
!write(*,*)' ttt=',ttt,' sss=',sss
sss2=sss/2.



!*************************************************************************
! Preliminary shape with only changed Z in the middle of the ray:
! Finding the time minimum:

tmin=ttt
ddd = val_bend0
bend=0

21 continue

	bend = bend + ddd

	sss=-sss2
	dxray(1)=0
	dyray(1)=0
	dzray(1)=0
	do inode=2,nodes
		x1=xray(inode-1)
		y1=yray(inode-1)
		z1=zray(inode-1) 

		x2=xray(inode)
		y2=yray(inode)
		z2=zray(inode)

		x3=xray(inode+1)
		y3=yray(inode+1)
		z3=zray(inode+1)

		dh=sqrt((x3-x1)*(x3-x1)+(y3-y1)*(y3-y1))
		dist=sqrt((z3-z1)*(z3-z1)+dh*dh)
		cosa=dh/dist
		sina=(z3-z1)/dist
		cosb=(x3-x1)/dh
		sinb=(y3-y1)/dh

		ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1))
		sss=sss+ds

		d_value = ddd*(1-(sss*sss)/(sss2*sss2))

		dxray(inode)= - d_value * sina * cosb
		dyray(inode)= - d_value * sina * sinb
		dzray(inode)= d_value * cosa

	end do
	dxray(nodes+1)=0
	dyray(nodes+1)=0
	dzray(nodes+1)=0

!do i=1,nodes
	!write(*,*)dxray(i),dyray(i),dzray(i)
!end do
!pause


	xray = xray + dxray
	yray = yray + dyray
	zray = zray + dzray

	ttt=0
	sss=0
	zmax=0
	do inode=1,nodes-1
		x1=xray(inode)
		x2=xray(inode+1)
		xm=(x1+x2)/2.

		y1=yray(inode)
		y2=yray(inode+1)
		ym=(y1+y2)/2.

		
		z1=zray(inode) 
		z2=zray(inode+1) 
		if(z1.gt.zmax) zmax=z1
		if(z2.gt.zmax) zmax=z2
		zm=(z1+z2)/2.

		ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1))
		!write(*,*)inode,ds,xm,ym,zm

		sss=sss+ds
		vvv=velocity (xm,ym,zm,ips)
		ttt=ttt+ds/vvv
		!write(*,*)' zm=',zm,' ds=',ds,' vvv=',vvv
	end do
	sss2=sss/2



	if(ttt.lt.tmin)then
		xmin=xray
		ymin=yray
		zmin=zray
		nmin=nodes
	end if
!	write(*,*)nodes,' zmax=',zmax,' ttt=',ttt,' sss=',sss

	ntmp=nodes
	xtmp=xray
	ytmp=yray
	ztmp=zray

	nodes=0

	do inode=1,ntmp
		x1=xtmp(inode)
		x2=xtmp(inode+1)

		y1=ytmp(inode)
		y2=ytmp(inode+1)
		
		z1=ztmp(inode) 
		z2=ztmp(inode+1) 

		dz1=ztmp(inode) 
		dz2=ztmp(inode+1) 

		nodes=nodes+1
		xray(nodes)=x1
		yray(nodes)=y1
		zray(nodes)=z1
		!write(*,*)' normal: ',ds,xray(nodes),yray(nodes),zray(nodes)

		ds=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)+(z2-z1)*(z2-z1))

		if(ds.gt.ds_ini*1.5) then
			nmid = ds/ds_ini + 1
			dsmid = ds/nmid
			do imid=1,nmid-1

				xmid=x1+((x2-x1)/ds)*(dsmid*imid)
				ymid=y1+((y2-y1)/ds)*(dsmid*imid)
				zmid=z1+((z2-z1)/ds)*(dsmid*imid)

				nodes=nodes+1
				xray(nodes)=xmid
				yray(nodes)=ymid
				zray(nodes)=zmid
			!write(*,*)'  mid: ',dsmid,xray(nodes),yray(nodes),zray(nodes)
			end do
		end if
	end do

	xray(nodes+1)=xtmp(ntmp+1)
	yray(nodes+1)=ytmp(ntmp+1)
	zray(nodes+1)=ztmp(ntmp+1)

	if(ttt.lt.tmin)then
		xmin=xray
		ymin=yray
		zmin=zray
		nmin=nodes
		tmin=ttt
	end if


if(bend.lt.bend_max0) goto 21


nodes=nmin
xray=xmin
yray=ymin
zray=zmin
tout=tmin

return
end