subroutine trace_bending(xzt,yzt,zzt,xst,yst,zst,ips,	tout)
common/ray/ nodes,xray(1000),yray(1000),zray(1000)
common/ray_min/ nrmin,xrmin(1000),yrmin(1000),zrmin(1000)
common/ray_part/ nrpart,xpart(1000),ypart(1000),zpart(1000),spart(1000),kod_part(1000)

real t_part(100)

ds_ini = 2
val_bend0 = 1
bend_max0 = 40
npart_max=30


call steight_line(xzt,yzt,zzt,xst,yst,zst,ips, tout)
write(*,*)' tout=',tout

tmin=tout
nrmin=nodes
xrmin=xray
yrmin=yray
zrmin=zray


part1=0.
part2=1.

sumbend=0

val_bend = 1

11 continue

	sumbend = sumbend + val_bend

	call part_ray(xzt,yzt,zzt,xst,yst,zst,ips,0.,1., tini)

	call part_bending_z(ips,val_bend, tout)

	call remeshing()
	zmax=0
	do i=1,nodes
		if(zray(i).gt.zmax) zmax=zray(i)
	end do
	!write(*,*)nodes,' sum=',sumbend,' zmax=',zmax,' t=',tout
	if(tout.lt.tmin) then
		tmin=tout
		nrmin=nodes
		xrmin=xray
		yrmin=yray
		zrmin=zray
	end if

if(sumbend.lt.bend_max0) goto 11

336 continue
do icase=1,2
	val_bend=(-1)**icase*val_bend0
	nodes=nrmin
	xray=xrmin
	yray=yrmin
	zray=zrmin
	call part_bending_hor(xzt,yzt,zzt,xst,yst,zst,ips, &
			part1,part2,val_bend, tout)
	if(tout.lt.tmin) then
		tmin=tout
		nrmin=nodes
		xrmin=xray
		yrmin=yray
		zrmin=zray
		goto 336
	end if
	!write(*,*)nodes,' val=',val_bend,' t=',tout
end do

write(*,*)nodes,' t=',tmin

nparts=1

do nparts=2,npart_max

	dpart=1./nparts
	do ip=1,nparts
		part1=(ip-1)*dpart
		part2=ip*dpart

		nodes=nrmin
		xray=xrmin
		yray=yrmin
		zray=zrmin
		val_bend=0
		write(*,*)' part=',ip
		call part_ray(xzt,yzt,zzt,xst,yst,zst,ips,part1,part2, tini)
		write(*,*)' tini=',tini

		do icase=1,2
			val_bend=(-1)**icase*(val_bend0/nparts)
			call part_bending_z(ips,val_bend, tout)
			write(*,*)' tout=',tout
		end do

		t_part(ip)=tout

	end do
	pause
	cycle

	do ip=1,nparts
		part1=(ip-1)*dpart
		part2=ip*dpart

		!write(*,*)' part1=',part1,' part2=',part2

	337	continue
		do icase=1,2
			val_bend=(-1)**icase*(val_bend0/nparts)
			nodes=nrmin
			xray=xrmin
			yray=yrmin
			zray=zrmin
			!call part_bending_z(xzt,yzt,zzt,xst,yst,zst,ips, &
					!part1,part2,val_bend, tout)

			!write(*,*)' ver:',nodes,' val=',val_bend,' t=',tout
			if(tout.lt.tmin) then
				call remeshing()
				tmin=tout
				nrmin=nodes
				xrmin=xray
				yrmin=yray
				zrmin=zray
				goto 337
			end if
		end do

		do icase=1,2
			val_bend=(-1)**icase*(val_bend0/nparts)
			nodes=nrmin
			xray=xrmin
			yray=yrmin
			zray=zrmin
			!call part_bending_hor(xzt,yzt,zzt,xst,yst,zst,ips, &
				!	part1,part2,val_bend, tout)

			!write(*,*)' hor:',nodes,' val=',val_bend,' t=',tout
			if(tout.lt.tmin) then
				call remeshing()
				tmin=tout
				nrmin=nodes
				xrmin=xray
				yrmin=yray
				zrmin=zray
				goto 337
			end if
		end do

	end do
	write(*,*)' nparts=',nparts,' tmin=',tmin

end do

pause

return
end
