function vrefmod(z,ips)

common/refmod/nrefmod,hmod(600),vmodp(600),vmods(600)

vrefmod=-900.
nref=nrefmod


if(nref.eq.0) then
	write(*,*)' the reference model is not defined!'
	pause
end if
!write(*,*)' z=',z,hmod(1),hmod(nref)
if(z.le.hmod(1))then
	z1=hmod(1)
	z2=hmod(2)
	if(ips.eq.1) then
		v1=vmodp(1)
		v2=vmodp(2)
	else
		v1=vmods(1)
		v2=vmods(2)
	end if
	vrefmod=v1+((v2-v1)/(z2-z1))*(z-z1)
else if(z.ge.hmod(nref)) then
	z2=hmod(nref)
	ii=1
773 continue
	z1=hmod(nref-ii)
	if(abs(z1-z2).lt.0.0001) then
		ii=ii+1
		goto 773
	end if
	if(ips.eq.1) then
		v1=vmodp(nref-ii)
		v2=vmodp(nref)
	else
		v1=vmods(nref-ii)
		v2=vmods(nref)
	end if
	vrefmod=v1+((v2-v1)/(z2-z1))*(z-z1)
	!write(*,*)' z=',z,' z1=',z1,' z2=',z2
	!write(*,*)' v1=',v1,' v2=',v2
	!write(*,*)' vrefmod=',vrefmod
end if

do i=1,nref-1
	z1=hmod(i)
	z2=hmod(i+1)
	if((z-z1)*(z-z2).gt.0.)cycle
	if(ips.eq.1) then
		v1=vmodp(i)
		v2=vmodp(i+1)
	else
		v1=vmods(i)
		v2=vmods(i+1)
	end if
	!write(*,*)' z=',z,' z1=',z1,' z2=',z2
	!write(*,*)' v1=',v1,' v2=',v2
	vrefmod=v1+((v2-v1)/(z2-z1))*(z-z1)
	!write(*,*)' vrefmod=',vrefmod
end do

return
end 